MODULE ConsoleDemo;

(* Dieses Demo veranschaulicht die Anwendung der Routinen des Moduls *)
(* ConsoleDevice. Dieses Demo ist Copyright-frei!                    *)

FROM SYSTEM	   IMPORT ADR,ADDRESS;
FROM IntuitionD    IMPORT WindowPtr,IDCMPFlags,IDCMPFlagSet,WindowFlags,
                          WindowFlagSet,ScreenFlagSet,NewWindow,ScreenFlags;
FROM IntuitionL    IMPORT OpenWindow,CloseWindow;
FROM ConsoleDevice IMPORT primary,columns,lines,Set,Read,Write,cls,ln,
                          leftOffset,OpenConsole,topOffset,CloseConsole,
                          MoveCursor,SetStyle,Cursor,off,SetCursor,underscore,
                          on,bold,up,down,left,right,italic,WriteChar,Inkey,
                          Scroll,ConsoleHandlePtr;
FROM DosL          IMPORT Delay;
FROM String        IMPORT Length;



CONST wait = 1;

VAR   ch   : ConsoleHandlePtr;

PROCEDURE SchreibLangsam(tx : ARRAY OF CHAR);
VAR g,t : INTEGER;
BEGIN
  FOR g:=0 TO Length(tx)-1 DO
    WriteChar(ch,tx[g]);
    Delay(wait);
  END;
END SchreibLangsam;



VAR d,r         : ARRAY[0..5] OF INTEGER;
    bs          : ARRAY[0..40] OF CHAR;
    g,q         : INTEGER;
    cb          : BOOLEAN;
    in,res,cs   : CHAR;
    win         : WindowPtr;
    nw          : NewWindow;

BEGIN

  r[0]:=right; r[1]:=up; r[2]:=left; r[3]:=down;

  (* ffne Workbenchwindow *)

  WITH nw DO
    topEdge:=20; leftEdge:=10; width:=610; height:=160; detailPen:=1;
    blockPen:=2; idcmpFlags:=IDCMPFlagSet{}; title:=ADR("ConsoleDevice-Demo");
    type:=ScreenFlagSet{wbenchScreen};
    flags:=WindowFlagSet{windowDrag,windowDepth,activate};
  END;
  win:=OpenWindow(nw);


  ch:=OpenConsole(win);  	(* ffne ConsoleDevice in dem Fenster *)

  Cursor(ch,on);		(* Cursor einschalten		      *)
  				(* (ist normal schon eingeschaltet)   *)
  cb:=on;			(* Flag, ob Cursor an oder aus ist    *)


  LOOP
    SetStyle(ch,underscore,1,2); (* Unterstreichen, Schriftfarbe 1, BGFarbe 2 *)
    Write(ch,cls);		 (* Fensterbereich lschen           *)
    SetCursor(ch,30,2);	         (* Cursor setzen                    *)
    SchreibLangsam("Console-Device-Demo");
    Write(ch,ln);   		 (* Entspricht `WriteLn` aus InOut   *)
    Write(ch,ln);
    Write(ch,ln);

    SetStyle(ch,primary,0,2);    (* Normalschrift wieder einschalten *)

    SchreibLangsam("        1 - Begrenzungsdemo"); Write(ch,ln); Write(ch,ln);
    SchreibLangsam("        2 - Cursordemo"); Write(ch,ln); Write(ch,ln);
    SchreibLangsam("        3 - Eingabedemo"); Write(ch,ln); Write(ch,ln);
    SchreibLangsam("        4 - Cursor ");
    IF cb THEN SchreibLangsam("aus"); ELSE SchreibLangsam("an"); END;

    Write(ch,ln); Write(ch,ln); Write(ch,ln);

    SchreibLangsam("        0 - Exit"); Write(ch,ln); Write(ch,ln); Write(ch,ln);
    SchreibLangsam("        Welche Nummer : ");


    REPEAT
      in:=Inkey(ch);       (* Warten bis Taste gedrckt (hier: von 0 - 4) *)
    UNTIL (in>='0') AND (in<='4');

    CASE in OF
    |'1':	(* Begrenzungsdemo *)
      SetStyle(ch,bold,3,1);
      Write(ch,cls);
      Write(ch,ln);
      SchreibLangsam(
      "        TopOffset = 50; LeftOffset = 100; Lines = 10; Columns = 49");
      Write(ch,ln);

      SetStyle(ch,primary,2,1);
      Set(ch,leftOffset,100); Set(ch,topOffset,50); Set(ch,lines,10);
      Set(ch,columns,49);

      FOR g:=0 TO 599 DO
        Write(ch,"| Test |");
      END;

      Write(ch,ln);

      SchreibLangsam("Stelle Normalzustand wieder her..."); Write(ch,ln);
      SchreibLangsam("Bitte eine Taste drcken!");

      REPEAT
        res:=Inkey(ch);   (* Wartet auf beliebige Taste *)
      UNTIL res#CHR(0);

      Set(ch,leftOffset,0); Set(ch,topOffset,0); Set(ch,lines,0);
      Set(ch,columns,0);

    |'2':	(* Cursordemo *)
      Cursor(ch,on);
      SetStyle(ch,bold,1,3);
      SetStyle(ch,italic,1,3);

      Write(ch,cls);
      SetCursor(ch,38,10);

      FOR g:=0 TO 18 DO
	FOR q:=0 TO g DIV 2 DO
	  MoveCursor(ch,1,r[g MOD 4]);
	  Delay(wait);
	END;
      END;

      SetCursor(ch,30,10);
      Write(ch,"Cursor blinkend : ");

      FOR g:=0 TO 11 DO
	cb:=NOT cb; Cursor(ch,cb);
        Delay(14*wait);
      END;

      SetStyle(ch,primary,1,3);


    |'3':	(* Eingabedemo *)
      SetStyle(ch,primary,1,0);
      Write(ch,cls);
      SetCursor(ch,5,7);

      Write(ch,"Bitte geben Sie Ihren Namen ein : ");
      Read(ch,20,bs);
      Write(ch,ln);

      q:=0; WHILE bs[q]#CHR(0) DO INC(q); END;

      Write(ch,"    Rckwrts geschrieben gibt das  : ");

      FOR g:=q-1 TO 0 BY -1 DO
        WriteChar(ch,CAP(bs[g]));
      END;
      Write(ch,ln);

      Delay(200*wait);

      FOR g:=0 TO 50 DO
	Scroll(ch,((g MOD 8)/4)*2-1);  (* Bildschirm 4x hoch und 4x runter *)
	Delay(2*wait);
      END;


    |'4':	(* Cursor an/aus *)
      cb:=NOT cb; Cursor(ch,cb);


    |'0':	(* Ausstieg *)
      EXIT;
    ELSE
    END;
  END;

CLOSE

  CloseConsole(ch);
  IF win#NIL THEN
    CloseWindow(win);
  END;

END ConsoleDemo.
